package ${basePackage!}.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.util.CyEpExcelUtil;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.exception.CyServiceException;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;


import ${basePackage!}.entity.${table.entityName!};
import ${basePackage!}.service.${table.entityName!}Service;

import java.util.List;

/**
* Created by ${author!} on ${.now}.
*/
@RestController
@RequestMapping("/${table.entityName?lower_case}")
public class ${table.entityName!}Controller extends CyPaginationController<${table.entityName!}> {

    <#if (table.tableRemark == "")>
        <#assign tableName = (table.entityName)>
    <#else>
        <#assign tableName = (table.tableRemark)>
    </#if>

    @Autowired
    private ${table.entityName!}Service ${table.entityName?uncap_first}ServiceImpl;

    //@PreAuthorize("@cyPerm.hasPerm('sys:${table.entityName?substring(3)?uncap_first}:add')")
    @CyOpeLogAnno(title = "${'system'}-${tableName!}管理-新增${tableName!}", businessType = CyLogTypeEnum.INSERT)
    @ApiOperation(value="添加${tableName!}", notes="添加${tableName!}")
    @PostMapping(value = "/add")
    public CyResult add(@Valid ${table.entityName!} ${table.entityName?uncap_first}, BindingResult bindingResult) {
        CyPersistModel data = ${table.entityName?uncap_first}ServiceImpl.persist(${table.entityName?uncap_first});
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first});
    }
    <#if table.idEntity == true>
    //@PreAuthorize("@cyPerm.hasPerm('sys:${table.entityName?substring(3)?uncap_first}:delete')")
    @CyOpeLogAnno(title = "${'system'}-${tableName!}管理-删除${tableName!}", businessType = CyLogTypeEnum.DELETE)
    @ApiOperation(value="逻辑删除${tableName!}", notes="逻辑删除${tableName!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/deleteLogical/{businessId:\\w+}")
    <#if table.increment == false>
    public CyResult deleteLogical(@PathVariable String businessId,${table.entityName!} ${table.entityName?uncap_first}) {
    </#if>
    <#if table.increment == true>
    public CyResult deleteLogical(@PathVariable int businessId,${table.entityName!} ${table.entityName?uncap_first}) {
    </#if>
        ${table.entityName?uncap_first}.setBusinessId(businessId);
        CyPersistModel data = ${table.entityName?uncap_first}ServiceImpl.removeLogical(${table.entityName?uncap_first});
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }
    </#if>
    //@PreAuthorize("@cyPerm.hasPerm('sys:${table.entityName?substring(3)?uncap_first}:delete')")
    @CyOpeLogAnno(title = "${'system'}-${tableName!}管理-删除${tableName!}", businessType = CyLogTypeEnum.DELETE)
    @ApiOperation(value="删除${tableName!}", notes="删除${tableName!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/delete/{businessId:\\w+}")
    <#if table.increment == false>
    public CyResult delete(@PathVariable String businessId,${table.entityName!} ${table.entityName?uncap_first}) {
    </#if>
    <#if table.increment == true>
    public CyResult delete(@PathVariable int businessId,${table.entityName!} ${table.entityName?uncap_first}) {
    </#if>
        ${table.entityName?uncap_first}.setBusinessId(businessId);
        CyPersistModel data = ${table.entityName?uncap_first}ServiceImpl.remove(${table.entityName?uncap_first});
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:${table.entityName?substring(3)?uncap_first}:update')")
    @CyOpeLogAnno(title = "${'system'}-${tableName!}管理-修改${tableName!}", businessType = CyLogTypeEnum.UPDATE)
    @ApiOperation(value="修改${tableName!}", notes="修改${tableName!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PutMapping("/update/{businessId:\\w+}")
    <#if table.increment == false>
    public CyResult update(@PathVariable String businessId, @Valid ${table.entityName!} ${table.entityName?uncap_first}, BindingResult bindingResult) {
    </#if>
    <#if table.increment == true>
    public CyResult update(@PathVariable int businessId, @Valid ${table.entityName!} ${table.entityName?uncap_first}, BindingResult bindingResult) {
    </#if>
        ${table.entityName?uncap_first}.setBusinessId(businessId);
        CyPersistModel data = ${table.entityName?uncap_first}ServiceImpl.merge(${table.entityName?uncap_first});
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first});
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:${table.entityName?substring(3)?uncap_first}:query')")
    @CyOpeLogAnno(title = "${'system'}-${tableName!}管理-查询${tableName!}", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="查询单一${tableName!}", notes="查询单一${tableName!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @GetMapping("/detail/{businessId:\\w+}")
    <#if table.increment == false>
    public CyResult detail(@PathVariable String businessId) {
    </#if>
    <#if table.increment == true>
    public CyResult detail(@PathVariable int businessId) {
    </#if>
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first}ServiceImpl.findById(businessId));
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:${table.entityName?substring(3)?uncap_first}:list')")
    @CyOpeLogAnno(title = "${'system'}-${tableName!}管理-查询${tableName!}", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="查询${tableName!}集合", notes="查询${tableName!}集合")
    @GetMapping(value = "/query${table.entityName!}s")
    public CyResult query${table.entityName!}s(${table.entityName!} ${table.entityName?uncap_first}) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
            ${table.entityName?uncap_first}ServiceImpl.findAll(${table.entityName?uncap_first}));
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:${table.entityName?substring(3)?uncap_first}:list')")
    @CyOpeLogAnno(title = "${'system'}-${tableName!}管理-查询${tableName!}", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="分页查询${tableName!}集合", notes="分页查询${tableName!}集合")
    @GetMapping(value = "/query${table.entityName!}ByPagination")
    public CyGridModel listByPagination(${table.entityName!} ${table.entityName?uncap_first}) {
        ${table.entityName?uncap_first}ServiceImpl.findAllByPagination(getPaginationUtility(), ${table.entityName?uncap_first});
        return getGridModelResponse();
    }

    @CyOpeLogAnno(title = "${'system'}-${tableName!}管理-查询${tableName!}", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出${tableName!}信息", notes = "导出${tableName!}信息")
    @GetMapping(value = "/export")
    public CyResult out${table.entityName!}(HttpServletResponse response,${table.entityName!} ${table.entityName?uncap_first},@PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName="";
        switch(excelId){
            case "0": excelName="${tableName!}信息.xls";break;
            case "1": excelName="${tableName!}信息.xlsx";break;
            case "2": excelName="${tableName!}信息.csv";break;
        }
        List<${table.entityName!}> ${table.entityName?uncap_first}List = ${table.entityName?uncap_first}ServiceImpl.export(${table.entityName?uncap_first});
        CyEpExcelUtil.exportExcel(${table.entityName?uncap_first}List, "${tableName!}信息", "${tableName!}信息", ${table.entityName!}.class, excelName, response);
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
            ${table.entityName?uncap_first}List);
    }
}
